const { join } = require('path');
const { config, env } = require('shakapacker');

module.exports = {
  test: /\.(js|mjs)$/,
  include: /node_modules/,
  exclude: [
    /@babel(?:\/|\\{1,2})runtime/,
    /tesseract.js/,
  ],
  use: [
    {
      loader: 'babel-loader',
      options: {
        babelrc: false,
        plugins: [
          'transform-react-remove-prop-types',
        ],
        cacheDirectory: join(config.cache_path, 'babel-loader-node-modules'),
        cacheCompression: env.isProduction,
        compact: false,
        sourceMaps: false,
      },
    },
  ],
};
